<?
/*  faceh / Joe McDermott, updated by Edmond Hui, Wolf
    http://www.faceh.com  

    History:
    v1.0  Initial version
    v1.1  bug fix on dateString == itime for new item (lastVisit cookie is updated on each reload.....)
    v1.2  add configuration menu to configure the use of icon 
    v1.3  - Fixed XHTML 1.0 warning
          - Fixed disabled cookie bug
          - Added sessionStart cookie to allow persistent until end of session (Thanks to Wolf for suggestion!)
          - use sql_table()
          - add supportsfeature('tableprefix') { return true }
    v1.3a - add min version support
 
*/

class NP_NewItem extends NucleusPlugin {

  // Note: I never run this plugin on 2.0 and have no idea whether it
  //       wil work on <2.5. A user can simply chnage it to return
  //       '200' and see if it works (likely will). I will gladly
  //       change the min version to 2.0 and add the sql_table fix
  //       upon such report. 8)
  function getMinNucleusVersion() { return '250'; }
  function getEventList() { return array('PostAuthentication'); }
  function getName() { return 'New Item';    }
  function getAuthor() { return 'faceh / admun / Wolf';    }
  function getURL() { return 'http://www.faceh.com'; }
  function getVersion() { return '1.3a'; }
  function getDescription() { return 'Displays New! next to new items'; }
  function install() {
    $this->createOption('use_icon','Use icon','yesno','yes');
    $this->createOption('icon_file','Icon graphics URL','text','http://some.where/nucleus/plugins/new.gif');
  }

  function supportsFeature($what) {
    switch($what) {
      case 'SqlTablePrefix':
        return 1;
      default:
        return 0;
    }
  }
   
  function event_PostAuthentication() {
    if (!isset($_COOKIE['sessionStart']))
      setcookie('sessionStart',$_COOKIE['lastVisit'],0,$CONF['CookiePath'],$CONF['CookieDomain'],$CONF['CookieSecure']);
  }

  function doTemplateVar(&$item) {

    // Only work if cookie function is turn on
    if ( ! is_null( cookieVar('lastVisit') ) &&
         ! cookieVar('lastVisit') == 0 ) {

    if (!isset($_COOKIE['sessionStart']))
      $dateString = mysqldate(cookieVar('lastVisit'));
    else
      $dateString = mysqldate(cookieVar('sessionStart')); 

      $query = 'SELECT inumber, itime FROM ' . sql_table('item') . ' WHERE inumber = ' . $item->itemid;

      $newitem = mysql_query($query);
      while($row = mysql_fetch_object($newitem)) {
        $row->itime = '"'.$row->itime.'"';

        if ($row->itime >= $dateString) {
          if ($this->getOption(use_icon) == "yes") { 
            echo "<img src=\"" . $this->getOption(icon_file) . "\" alt=\"[New]\" />";
          } else {
            echo "<font color=\"#FF0000\"> [NEW!]</font>";
          }
        }
      }
    }
  }
}
?>
